package lector_y_escritor;

import javax.swing.*;
import java.awt.*;

public class Marco extends JFrame {

    public JPanel panel;
    public JTextArea area;
    public JTextField escritor, lector;
    public JLabel etiquetaEscritor, etiquetaLector, etiquetaFondo;
    public JScrollPane barra;
    public JButton ejecutar, borrar;

    public Marco(){
      setSize(500,500);
      setLocationRelativeTo(null);
      setResizable(false);
      setDefaultCloseOperation(EXIT_ON_CLOSE);
      setTitle("LECTORES Y ESCRITORES");

      interfaz();
    }

    public void interfaz(){
        panel();
        areaTexto();
        campos();
        etiqueta();
        botones();
        fondo();

    }

    public void panel(){
        panel = new JPanel();
        panel.setLayout(null);
        this.getContentPane().add(panel);
    }

    public void areaTexto(){
        area = new JTextArea();
        area.setFont(new Font("Arial",0,20));
        area.setEditable(false);
        barra = new JScrollPane(area);
        barra.setBounds(10,150,460,300);
        panel.add(barra);
    }

    public void etiqueta(){
        etiquetaEscritor = new JLabel("Ingresar la número de escritores");
        etiquetaEscritor.setBounds(10,0,300,50);
        etiquetaEscritor.setForeground(Color.WHITE);
        etiquetaEscritor.setFont(new Font("arial", 1,14));
        panel.add(etiquetaEscritor);

        etiquetaLector = new JLabel("Ingresar la número de lectores");
        etiquetaLector.setBounds(10,60,300,50);
        etiquetaLector.setForeground(Color.WHITE);
        etiquetaLector.setFont(new Font("arial", 1,14));
        panel.add(etiquetaLector);
    }

    public void campos(){
        escritor = new JTextField("");
        escritor.setForeground(Color.black);
        escritor.setFont(new Font("arial", 1,25));
        escritor.setBounds(10,35,50,40);
        panel.add(escritor);

        lector = new JTextField("");
        lector.setForeground(Color.black);
        lector.setFont(new Font("arial", 1,25));
        lector.setBounds(10,100,50,40);
        panel.add(lector);
    }

    public void botones(){
        ImageIcon botonCalcularImg = new ImageIcon("iniciar.png");
        ejecutar = new JButton();
        ejecutar.setBounds(260, 20, 92, 92);
        ejecutar.setIcon(botonCalcularImg);
        ejecutar.setContentAreaFilled(false);
        ejecutar.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
        panel.add(ejecutar);

        ejecutar.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(java.awt.event.ActionEvent eventoCalcular) {
                botonCalcularAccion(eventoCalcular);
            }
        });

        ImageIcon botonBorrarImg = new ImageIcon("borrar.png");
        borrar = new JButton();
        borrar.setBounds(360, 20, 92, 92);
        borrar.setIcon(botonBorrarImg);
        borrar.setContentAreaFilled(false);
        borrar.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
        panel.add(borrar);
/*
        borrar.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(java.awt.event.ActionEvent eventoCalcular) {
                botonBorrarAccion(eventoCalcular);
            }
        });*/
    }

    public void botonCalcularAccion(java.awt.event.ActionEvent eventoCalcular){

        int escritores = Integer.parseInt(escritor.getText());
        int lectores = Integer.parseInt(lector.getText());

        ControladorIngresoBD gestor = new ControladorIngresoBD();
        Escritor[] escritor = new Escritor[escritores];
        Lector[] lector = new Lector[lectores];

        for (int i = 0; i < escritor.length; i++){
            escritor[i] = new Escritor(gestor,i);
        }
        for (int i = 0; i < lector.length; i++){
            lector[i] = new Lector(gestor,i);
        }

        for (int i = 0; i < escritor.length; i++){
            escritor[i].start();
        }
        for (int i = 0; i < lector.length; i++){
            lector[i].start();
        }
    }

    public void fondo(){
        etiquetaFondo = new JLabel(new ImageIcon("fondo.png"));
        etiquetaFondo.setBounds(0, 0, 500, 500);
        panel.add(etiquetaFondo);
    }

    public void mostrar(String msg){
        area.setText(msg);
    }
}
